function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var _ = _interopDefault(require('lodash'));
var React = require('react');
var React__default = _interopDefault(React);
var useDeepCompareEffect = require('use-deep-compare-effect');
var awsAmplify = require('aws-amplify');

// A type of promise-like that resolves synchronously and supports only one observer

const _iteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator"))) : "@@iterator";

const _asyncIteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.asyncIterator || (Symbol.asyncIterator = Symbol("Symbol.asyncIterator"))) : "@@asyncIterator";

// Asynchronously call a function and send errors to recovery continuation
function _catch(body, recover) {
	try {
		var result = body();
	} catch(e) {
		return recover(e);
	}
	if (result && result.then) {
		return result.then(void 0, recover);
	}
	return result;
}

// Asynchronously await a promise and pass the result to a finally continuation
function _finallyRethrows(body, finalizer) {
	try {
		var result = body();
	} catch (e) {
		return finalizer(true, e);
	}
	if (result && result.then) {
		return result.then(finalizer.bind(null, false), finalizer.bind(null, true));
	}
	return finalizer(false, result);
}

var currentUser = function currentUser() {
  try {
    var user = null;

    var _temp2 = _catch(function () {
      return Promise.resolve(awsAmplify.Auth.currentAuthenticatedUser()).then(function (_Auth$currentAuthenti) {
        user = _Auth$currentAuthenti;
      });
    }, function (e) {
      console.log(e);
    });

    return Promise.resolve(_temp2 && _temp2.then ? _temp2.then(function () {
      return user;
    }) : user);
  } catch (e) {
    return Promise.reject(e);
  }
};

var graphqlOperation = function graphqlOperation(query, variables) {
  try {
    return Promise.resolve(currentUser()).then(function (user) {
      var authMode = variables !== null && variables !== void 0 && variables.authMode ? variables === null || variables === void 0 ? void 0 : variables.authMode : user ? "AMAZON_COGNITO_USER_POOLS" : "AWS_IAM";
      return Promise.resolve(awsAmplify.API.graphql({
        query: query,
        authMode: authMode,
        variables: variables
      })).then(function (_ref) {
        var data = _ref.data;
        return data;
      });
    });
  } catch (e) {
    return Promise.reject(e);
  }
};

var useQuery = function useQuery(query, variables) {
  var _React$useState = React__default.useState(true),
      loading = _React$useState[0],
      setLoading = _React$useState[1];

  var _React$useState2 = React__default.useState(false),
      mutationLoading = _React$useState2[0],
      setMutationLoading = _React$useState2[1];

  var _React$useState3 = React__default.useState(""),
      error = _React$useState3[0];

  var _React$useState4 = React__default.useState([]),
      data = _React$useState4[0],
      setData = _React$useState4[1];

  var _React$useState5 = React__default.useState([]);

  var mutation = function mutation(query, variables) {
    try {
      var _exit2 = false;
      var _data = null;

      var _temp2 = _catch(function () {
        return Promise.resolve(setMutationLoading(true)).then(function () {
          return Promise.resolve(graphqlOperation(query, variables)).then(function (_graphqlOperation) {
            _data = _graphqlOperation;
            return Promise.resolve(setMutationLoading(false)).then(function () {
              _exit2 = true;
              return _data;
            });
          });
        });
      }, function (e) {
        console.log(e);
        return Promise.resolve(setMutationLoading(false)).then(function () {
          _data = e;
        });
      });

      return Promise.resolve(_temp2 && _temp2.then ? _temp2.then(function (_result) {
        return _exit2 ? _result : _data;
      }) : _exit2 ? _temp2 : _data);
    } catch (e) {
      return Promise.reject(e);
    }
  };

  var fetchQuery = function fetchQuery(query, variables, concat) {
    try {
      setLoading(true);
      return Promise.resolve(graphqlOperation(query, variables)).then(function (newData) {
        if (variables && variables !== null && variables !== void 0 && variables.nextToken && concat) {
          var _ref, _newData$variables$na, _newData$variables$na2, _setData;

          var node = _.get(data, variables.name);

          setData((_setData = {}, _setData[variables.name] = {
            items: (_ref = (node === null || node === void 0 ? void 0 : node.items) || []) === null || _ref === void 0 ? void 0 : _ref.concat((_newData$variables$na = newData[variables.name]) === null || _newData$variables$na === void 0 ? void 0 : _newData$variables$na.items),
            nextToken: (_newData$variables$na2 = newData[variables.name]) === null || _newData$variables$na2 === void 0 ? void 0 : _newData$variables$na2.nextToken
          }, _setData));
        } else {
          setData(newData);
        }

        setLoading(false);
      });
    } catch (e) {
      return Promise.reject(e);
    }
  };

  var refetch = function refetch() {
    if (query) fetchQuery(query, variables, false);
  };

  useDeepCompareEffect.useDeepCompareEffectNoCheck(function () {
    if (query) fetchQuery(query, variables, true);
  }, [query, variables]);
  return {
    loading: loading,
    data: data,
    error: error,
    refetch: refetch,
    mutation: mutation,
    mutationLoading: mutationLoading
  };
};

var useMutation = function useMutation(mutation, options) {
  var _React$useState = React__default.useState(false),
      loading = _React$useState[0],
      setLoading = _React$useState[1];

  var _React$useState2 = React__default.useState(""),
      error = _React$useState2[0],
      setError = _React$useState2[1];

  var _React$useState3 = React__default.useState(null),
      data = _React$useState3[0],
      setData = _React$useState3[1];

  var mutate = function mutate(variables) {
    try {
      return Promise.resolve(setLoading(true)).then(function () {
        return Promise.resolve(graphqlOperation(mutation, variables)).then(function (result) {
          return Promise.resolve(setError(result.error)).then(function () {
            return Promise.resolve(setData(result)).then(function () {
              return Promise.resolve(setLoading(false)).then(function () {
                return result;
              });
            });
          });
        });
      });
    } catch (e) {
      return Promise.reject(e);
    }
  };

  return [mutate, {
    data: data,
    loading: loading,
    error: error
  }];
};

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };
  return _extends.apply(this, arguments);
}

var useSubscription = function useSubscription(query, variables, options) {
  var _useState = React.useState(""),
      error = _useState[0];

  var _useState2 = React.useState(false),
      loading = _useState2[0],
      setLoading = _useState2[1];

  var _useState3 = React.useState(null),
      data = _useState3[0],
      setData = _useState3[1];

  React.useEffect(function () {
    var subscription = null;

    var setUpSubscription = function setUpSubscription() {
      try {
        return Promise.resolve(awsAmplify.Auth.currentAuthenticatedUser()).then(function (user) {
          var authMode = options !== null && options !== void 0 && options.authMode ? options === null || options === void 0 ? void 0 : options.authMode : user ? "AMAZON_COGNITO_USER_POOLS" : "AWS_IAM";
          var queryVariables = user && options !== null && options !== void 0 && options.withOwner ? _extends({}, variables, {
            owner: user === null || user === void 0 ? void 0 : user.username
          }) : variables;
          subscription = awsAmplify.API.graphql({
            authMode: authMode,
            query: query,
            variables: queryVariables
          }).subscribe({
            next: function next(payload) {
              var _payload$value;

              setLoading(true);
              var data = (_payload$value = payload.value) === null || _payload$value === void 0 ? void 0 : _payload$value.data;
              setData(data);
              (options === null || options === void 0 ? void 0 : options.onSubscriptionData) && data && (options === null || options === void 0 ? void 0 : options.onSubscriptionData(data));
              setLoading(false);
            }
          });
        });
      } catch (e) {
        return Promise.reject(e);
      }
    };

    setUpSubscription();
    return function () {
      var _subscription;

      subscription && ((_subscription = subscription) === null || _subscription === void 0 ? void 0 : _subscription.unsubscribe());
    };
  }, [variables]);
  return {
    loading: loading,
    data: data,
    error: error
  };
};

(function (AuthMode) {
  AuthMode["AWS_IAM"] = "AWS_IAM";
  AuthMode["AMAZON_COGNITO_USER_POOLS"] = "AMAZON_COGNITO_USER_POOLS";
})(exports.AuthMode || (exports.AuthMode = {}));

var useLazyQuery = function useLazyQuery(query) {
  var _React$useState = React__default.useState(1),
      totalPages = _React$useState[0],
      setTotalPages = _React$useState[1];

  var _React$useState2 = React__default.useState(false),
      loading = _React$useState2[0],
      setLoading = _React$useState2[1];

  var _React$useState3 = React__default.useState(""),
      error = _React$useState3[0],
      setErrors = _React$useState3[1];

  var _React$useState4 = React__default.useState([]),
      data = _React$useState4[0],
      setData = _React$useState4[1];

  var _React$useState5 = React__default.useState([undefined]),
      nextTokens = _React$useState5[0],
      setNextTokens = _React$useState5[1];

  var execute = function execute(variables) {
    try {
      return Promise.resolve(_finallyRethrows(function () {
        return _catch(function () {
          return Promise.resolve(setLoading(true)).then(function () {
            return Promise.resolve(graphqlOperation(query, variables)).then(function (response) {
              setData(response);
              if (response.errors) setErrors(response.errors);
              var token = response[variables === null || variables === void 0 ? void 0 : variables.name].nextToken;
              if (!token) return;
              checkNextPage(variables.page, variables, token);
            });
          });
        }, function (e) {
          setErrors(e);
        });
      }, function (_wasThrown, _result) {
        return Promise.resolve(setLoading(false)).then(function () {
          if (_wasThrown) throw _result;
          return _result;
        });
      }));
    } catch (e) {
      return Promise.reject(e);
    }
  };

  var checkNextPage = function checkNextPage(page, variables, token) {
    try {
      if (!token) return Promise.resolve();
      return Promise.resolve(graphqlOperation(query, _extends({}, variables, {
        nextToken: token
      }))).then(function (response) {
        var _temp = function () {
          var _response$variables$n;

          if (variables && response && response[variables === null || variables === void 0 ? void 0 : variables.name] && ((_response$variables$n = response[variables === null || variables === void 0 ? void 0 : variables.name]) === null || _response$variables$n === void 0 ? void 0 : _response$variables$n.items.length) > 0) {
            var shallow = nextTokens;
            var nextPage = page + 1;
            shallow[nextPage] = token;
            return Promise.resolve(setNextTokens([].concat(shallow))).then(function () {
              return Promise.resolve(setTotalPages(shallow.length)).then(function () {});
            });
          }
        }();

        if (_temp && _temp.then) return _temp.then(function () {});
      });
    } catch (e) {
      return Promise.reject(e);
    }
  };

  return [execute, {
    data: data,
    loading: loading,
    error: error,
    nextTokens: nextTokens,
    setNextTokens: setNextTokens,
    totalPages: totalPages
  }];
};

var useLazySubscription = function useLazySubscription(query) {
  var _useState = React.useState(""),
      error = _useState[0];

  var _useState2 = React.useState(false),
      loading = _useState2[0],
      setLoading = _useState2[1];

  var _useState3 = React.useState(null),
      data = _useState3[0],
      setData = _useState3[1];

  var subscription = null;

  var execute = function execute(variables, options) {
    try {
      return Promise.resolve(awsAmplify.Auth.currentAuthenticatedUser()).then(function (user) {
        var authMode = options !== null && options !== void 0 && options.authMode ? options === null || options === void 0 ? void 0 : options.authMode : user ? "AMAZON_COGNITO_USER_POOLS" : "AWS_IAM";
        var queryVariables = user && options !== null && options !== void 0 && options.withOwner ? _extends({}, variables, {
          owner: user === null || user === void 0 ? void 0 : user.username
        }) : variables;
        subscription = awsAmplify.API.graphql({
          authMode: authMode,
          query: query,
          variables: queryVariables
        }).subscribe({
          next: function next(payload) {
            var _payload$value;

            setLoading(true);
            var data = (_payload$value = payload.value) === null || _payload$value === void 0 ? void 0 : _payload$value.data;
            setData(data);
            (options === null || options === void 0 ? void 0 : options.onSubscriptionData) && data && (options === null || options === void 0 ? void 0 : options.onSubscriptionData(data));
            setLoading(false);
          }
        });
      });
    } catch (e) {
      return Promise.reject(e);
    }
  };

  React.useEffect(function () {
    return function () {
      var _subscription;

      subscription && ((_subscription = subscription) === null || _subscription === void 0 ? void 0 : _subscription.unsubscribe());
    };
  }, []);
  return [execute, {
    data: data,
    loading: loading,
    error: error
  }];
};

var usePaginatedQuery = function usePaginatedQuery(query, variables) {
  var _React$useState = React__default.useState(true),
      loading = _React$useState[0],
      setLoading = _React$useState[1];

  var _React$useState2 = React__default.useState(""),
      errors = _React$useState2[0],
      setErrors = _React$useState2[1];

  var _React$useState3 = React__default.useState([]),
      data = _React$useState3[0],
      setData = _React$useState3[1];

  var _React$useState4 = React__default.useState(1),
      totalPages = _React$useState4[0],
      setTotalPages = _React$useState4[1];

  var _React$useState5 = React__default.useState([undefined]),
      nextTokens = _React$useState5[0],
      setNextTokens = _React$useState5[1];

  var _React$useState6 = React__default.useState(0),
      page = _React$useState6[0],
      setPage = _React$useState6[1];

  var _React$useState7 = React__default.useState(undefined),
      nextToken = _React$useState7[0],
      setNextToken = _React$useState7[1];

  var fetchQuery = function fetchQuery(query, variables) {
    try {
      return Promise.resolve(_finallyRethrows(function () {
        return _catch(function () {
          setLoading(true);
          return Promise.resolve(graphqlOperation(query, _extends({}, variables, {
            nextToken: nextToken
          }))).then(function (response) {
            setData(response);
            if (response.errors) setErrors(response.errors);
            var token = response[variables === null || variables === void 0 ? void 0 : variables.name].nextToken;
            if (!token) return;
            checkNextPage(page, token);
          });
        }, function (e) {
          setErrors(e);
        });
      }, function (_wasThrown, _result) {
        return Promise.resolve(setLoading(false)).then(function () {
          if (_wasThrown) throw _result;
          return _result;
        });
      }));
    } catch (e) {
      return Promise.reject(e);
    }
  };

  var checkNextPage = function checkNextPage(page, token) {
    try {
      if (!token) return Promise.resolve();
      return Promise.resolve(graphqlOperation(query, _extends({}, variables, {
        nextToken: token
      }))).then(function (response) {
        var _response$variables$n;

        if (response && response[variables.name] && ((_response$variables$n = response[variables.name]) === null || _response$variables$n === void 0 ? void 0 : _response$variables$n.items.length) > 0) {
          var shallow = nextTokens;
          var nextPage = page + 1;
          shallow[nextPage] = token;
          setNextTokens([].concat(shallow));
          setTotalPages(shallow.length);
        }
      });
    } catch (e) {
      return Promise.reject(e);
    }
  };

  var refetch = function refetch() {
    try {
      if (!query) return Promise.resolve();

      var _temp2 = _finallyRethrows(function () {
        return _catch(function () {
          setLoading(true);
          return Promise.resolve(graphqlOperation(query, _extends({}, variables, {
            nextToken: nextToken
          }))).then(function (response) {
            setData(response);
            if (response.errors) setErrors(response.errors);
          });
        }, function (e) {
          setErrors(e);
        });
      }, function (_wasThrown2, _result2) {
        return Promise.resolve(setLoading(false)).then(function () {
          if (_wasThrown2) throw _result2;
          return _result2;
        });
      });

      return Promise.resolve(_temp2 && _temp2.then ? _temp2.then(function () {}) : void 0);
    } catch (e) {
      return Promise.reject(e);
    }
  };

  useDeepCompareEffect.useDeepCompareEffectNoCheck(function () {
    if (query) fetchQuery(query, variables);
  }, [query, variables, nextToken]);
  React.useEffect(function () {
    if (page === 0) {
      setNextToken(undefined);
      return;
    }

    setNextToken(nextTokens[page]);
  }, [page]);
  return {
    loading: loading,
    data: data,
    errors: errors,
    refetch: refetch,
    nextTokens: nextTokens,
    setNextTokens: setNextTokens,
    nextToken: nextToken,
    setNextToken: setNextToken,
    totalPages: totalPages,
    page: page,
    setPage: setPage
  };
};

var useDataStoreQuery = function useDataStoreQuery(entity) {
  var _useState = React.useState(false),
      loading = _useState[0],
      setLoading = _useState[1];

  var _useState2 = React.useState(""),
      error = _useState2[0],
      setErrors = _useState2[1];

  var _useState3 = React.useState([]),
      data = _useState3[0],
      setData = _useState3[1];

  var execute = function execute(query, pagination) {
    try {
      var response = null;

      var _temp2 = _finallyRethrows(function () {
        return _catch(function () {
          setLoading(true);
          return Promise.resolve(awsAmplify.DataStore.query(entity, query, pagination)).then(function (_DataStore$query) {
            response = _DataStore$query;
            setData(response);
            if (response.errors) setErrors(response.errors);
          });
        }, function (e) {
          setErrors(e);
        });
      }, function (_wasThrown, _result) {
        setLoading(false);
        if (_wasThrown) throw _result;
        return _result;
      });

      return Promise.resolve(_temp2 && _temp2.then ? _temp2.then(function () {
        return response;
      }) : response);
    } catch (e) {
      return Promise.reject(e);
    }
  };

  return [execute, {
    data: data,
    loading: loading,
    error: error
  }];
};

var useDataStoreSave = function useDataStoreSave(entity) {
  var _useState = React.useState(false),
      loading = _useState[0],
      setLoading = _useState[1];

  var _useState2 = React.useState(""),
      error = _useState2[0],
      setErrors = _useState2[1];

  var _useState3 = React.useState([]),
      data = _useState3[0],
      setData = _useState3[1];

  var execute = function execute(entity) {
    try {
      var response = null;

      var _temp2 = _finallyRethrows(function () {
        return _catch(function () {
          setLoading(true);
          return Promise.resolve(awsAmplify.DataStore.save(entity)).then(function (_DataStore$save) {
            response = _DataStore$save;
            setData(response);
            if (response.errors) setErrors(response.errors);
          });
        }, function (e) {
          setErrors(e);
        });
      }, function (_wasThrown, _result) {
        setLoading(false);
        if (_wasThrown) throw _result;
        return _result;
      });

      return Promise.resolve(_temp2 && _temp2.then ? _temp2.then(function () {
        return response;
      }) : response);
    } catch (e) {
      return Promise.reject(e);
    }
  };

  return [execute, {
    data: data,
    loading: loading,
    error: error
  }];
};

var useDataStoreDelete = function useDataStoreDelete(entity) {
  var _useState = React.useState(false),
      loading = _useState[0],
      setLoading = _useState[1];

  var _useState2 = React.useState(""),
      error = _useState2[0],
      setErrors = _useState2[1];

  var _useState3 = React.useState([]),
      data = _useState3[0],
      setData = _useState3[1];

  var execute = function execute(entity, predicates) {
    try {
      var response = null;

      var _temp2 = _finallyRethrows(function () {
        return _catch(function () {
          setLoading(true);
          return Promise.resolve(awsAmplify.DataStore["delete"](entity, predicates)).then(function (_DataStore$delete) {
            response = _DataStore$delete;
            setData(response);
            if (response.errors) setErrors(response.errors);
          });
        }, function (e) {
          setErrors(e);
        });
      }, function (_wasThrown, _result) {
        setLoading(false);
        if (_wasThrown) throw _result;
        return _result;
      });

      return Promise.resolve(_temp2 && _temp2.then ? _temp2.then(function () {}) : void 0);
    } catch (e) {
      return Promise.reject(e);
    }
  };

  return [execute, {
    data: data,
    loading: loading,
    error: error
  }];
};

exports.currentUser = currentUser;
exports.graphqlOperation = graphqlOperation;
exports.useDataStoreDelete = useDataStoreDelete;
exports.useDataStoreQuery = useDataStoreQuery;
exports.useDataStoreSave = useDataStoreSave;
exports.useLazyQuery = useLazyQuery;
exports.useLazySubscription = useLazySubscription;
exports.useMutation = useMutation;
exports.usePaginatedQuery = usePaginatedQuery;
exports.useQuery = useQuery;
exports.useSubscription = useSubscription;
//# sourceMappingURL=index.js.map
